unit dati;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Grids, DBGrids, Buttons, DB, DBTables;

type
  TfDati = class(TForm)
    PnlDati: TPanel;
    dbgJautajumi: TDBGrid;
    BtnPievienot: TBitBtn;
    BtnDzest: TBitBtn;
    BtnBeigt: TBitBtn;
    BtnApstip: TBitBtn;
    BtnAtcelt: TBitBtn;
    tJautajumi: TTable;
    tJautajumiNUMURS: TFloatField;
    tJautajumiJAUTAJUMS: TStringField;
    tJautajumiVAR1: TStringField;
    tJautajumiVAR2: TStringField;
    tJautajumiVAR3: TStringField;
    tJautajumiATBILDE: TSmallintField;
    sJautajumi: TDataSource;
    qTemp: TQuery;
    procedure BtnPievienotClick(Sender: TObject);
    procedure BtnDzestClick(Sender: TObject);
    procedure BtnBeigtClick(Sender: TObject);
    procedure BtnApstipClick(Sender: TObject);
    procedure BtnAtceltClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tJautajumiNewRecord(DataSet: TDataSet);
    procedure sJautajumiStateChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function Sequence(DataSet: TDataSet): String;
  end;

var
  fDati: TfDati;

implementation

{uses Jautajumi;}

{$R *.DFM}


function TfDati.Sequence(DataSet: TDataSet): String;
var
      vKd_New : String[4];
begin
   qTemp.Close;
   qTemp.SQL.Clear;
   qTemp.SQL.Add('SELECT MAX(' + DataSet.Fields[0].FieldName + ') FROM ' +
      (DataSet as TTable).TableName);
   qTemp.Open;
   if qTemp.Fields[0].Value = Null
      then vKd_New := '1'
      else vKd_New := IntToStr(StrToInt( qTemp.Fields[0].Value ) + 1);
    Sequence := vKd_New;
end;


procedure TfDati.BtnPievienotClick(Sender: TObject);
begin
   tJautajumi.Append;
   dbgJautajumi.SetFocus;
end;

procedure TfDati.BtnDzestClick(Sender: TObject);
begin
   tJautajumi.Delete;
   dbgJautajumi.SetFocus;
end;

procedure TfDati.BtnBeigtClick(Sender: TObject);
begin
   Close;
end;

procedure TfDati.BtnApstipClick(Sender: TObject);
begin
   tJautajumi.Post;
   dbgJautajumi.SetFocus;
end;

procedure TfDati.BtnAtceltClick(Sender: TObject);
begin
   tJautajumi.Cancel;
   dbgJautajumi.SetFocus;
end;

procedure TfDati.FormClose(Sender: TObject; var Action: TCloseAction);
var
   Statuss : TDataSetState;
begin
   Statuss := sJautajumi.State;
   if ( Statuss = dsInsert ) or ( Statuss = dsEdit ) then
      case MessageDlg('Vai saglabt izmaias ?',mtConfirmation,[mbYes,mbNo,mbCancel],0 ) of
      mrYes    : tJautajumi.Post;
      mrNo     : tJautajumi.Cancel;
      mrCancel :
         begin
            dbgJautajumi.SetFocus;
            Abort;
         end;
      end;
end;

procedure TfDati.tJautajumiNewRecord(DataSet: TDataSet);
begin
tJautajumi.Fields[0].Value := Sequence(DataSet);
end;

procedure TfDati.sJautajumiStateChange(Sender: TObject);
var
   Statuss : TDataSetState;
begin
   Statuss := sJautajumi.State;
   case Statuss of
      dsInactive :
         begin
            btnPievienot.Enabled := FALSE;
            btnDzest.Enabled     := FALSE;
            btnApstip.Enabled    := FALSE;
            btnAtcelt.Enabled    := FALSE;
         end;
      dsBrowse   :
         begin
            btnPievienot.Enabled := TRUE;
            btnDzest.Enabled     := TRUE;
            btnApstip.Enabled    := FALSE;
            btnAtcelt.Enabled    := FALSE;
         end;
      dsInsert   :
         begin
            btnPievienot.Enabled := FALSE;
            btnDzest.Enabled     := FALSE;
            btnApstip.Enabled    := TRUE;
            btnAtcelt.Enabled    := TRUE;
         end;
      dsEdit     :
         begin
            btnPievienot.Enabled := FALSE;
            btnDzest.Enabled     := FALSE;
            btnApstip.Enabled    := TRUE;
            btnAtcelt.Enabled    := TRUE;
         end;
   end;

end;

end.
